︠defb0cbf-51fa-435c-9bd6-58d2d3b7cc9fs︠
A=matrix(3,3,[0,1,1,0,0,1,-1,1,1]);
B=matrix(3,3,[0,2/3,2/3,0,0,2/3,-1/3,2/3,2/3])
show(A)
show(B)
C=matrix(B*(A^(-1)))
show(C)
︡ecfe3db0-407b-41fb-b17c-1300113d4e1f︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrr}\n0 &amp; 1 &amp; 1 \\\\\n0 &amp; 0 &amp; 1 \\\\\n-1 &amp; 1 &amp; 1\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrr}\n0 &amp; \\frac{2}{3} &amp; \\frac{2}{3} \\\\\n0 &amp; 0 &amp; \\frac{2}{3} \\\\\n-\\frac{1}{3} &amp; \\frac{2}{3} &amp; \\frac{2}{3}\n\\end{array}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrr}\n\\frac{2}{3} &amp; 0 &amp; 0 \\\\\n0 &amp; \\frac{2}{3} &amp; 0 \\\\\n\\frac{1}{3} &amp; 0 &amp; \\frac{1}{3}\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠1cdfec14-5c0c-4e52-8121-cc64c9d70549s︠
#Entonces la transformación proyectiva que manda los puntos (0,0,1), (1,0,1), (1,1,1); (2,1,1)
#a los puntos (0,0,1), (1,0,1),(1,1,0); (4/3,2/3,1) está dada por la matriz C
#La transformación del plano en el plano asociada es la transformación
#f(x,y)=(  ((2/3)x+0y+0)/(1x-(2/3)y-1/3),  (0x+(2/3)y +0)/(1x-(2/3)y-1/3))=(2x/(3x-2y-1),2y/(3x-2y+1))
︡04c6ed96-4dd5-49b7-9c08-90cbd2e3d11b︡{"done":true}︡
︠7574ae73-a717-4c28-a2cf-e9562104ac16s︠
var('x y')
def myf(x,y):
    return (2*x/(x+1),2*y/(x+1))
show(myf)
︡cc33ae85-c794-41f3-88a3-c291b536a1bb︡{"stdout":"(x, y)\n"}︡{"stdout":"<function myf at 0x7f1197d1fde8>\n"}︡{"done":true}︡
︠c8e62989-61e4-41e2-89f4-5bf6cfeba333s︠
for i,j in ((0,0),(1,0),(1,1),(2,1)):
    show(myf(i,j))
︡c58d7436-1398-47e2-86eb-513a007cc167︡{"html":"<div align='center'>($\\displaystyle 0$, $\\displaystyle 0$)</div>"}︡{"html":"<div align='center'>($\\displaystyle 1$, $\\displaystyle 0$)</div>"}︡{"html":"<div align='center'>($\\displaystyle 1$, $\\displaystyle 1$)</div>"}︡{"html":"<div align='center'>($\\displaystyle \\frac{4}{3}$, $\\displaystyle \\frac{2}{3}$)</div>"}︡{"done":true}︡
︠5048ca9d-caed-470f-884c-33471fa58096s︠
maxiter=30
G=Graphics()
for i in range(maxiter):
    for j in range(i+1):
        if (i,j)==(0,0):
            show("(0,0) should be there")
        G+=point(myf(i,j),size=40/(i+1))
H=Graphics()
for i in range(int(maxiter)):
    H+=line([(2,2),(myf(i,0))],color='red',thickness=.1)
for i in range(int(maxiter)):
    H+=line([(2,0),(myf(i,i))],color='red',thickness=.1)
(H+G).show(aspect_ratio=1)
︡4a4631ed-5257-4acb-ae99-df4219e96dca︡{"html":"<div align='center'>(0,0) should be there</div>"}︡{"file":{"filename":"/home/user/.sage/temp/project-0e2295c1-fb40-4d14-a8b4-83cc20956ee4/308/tmp_p29zTF.svg","show":true,"text":null,"uuid":"f7ab84a9-8679-4c24-ac13-8fe22f3d1b7d"},"once":false}︡{"done":true}︡
︠20a56336-6059-4fc6-978d-4c9f9588176bs︠
p=(1,2)
v=vector([10,10])
myf(*v)
︡f911ca1e-d552-4a1b-8f18-d8be5fb0bfba︡{"stdout":"(20/11, 20/11)\n"}︡{"done":true}︡
︠96d79e7b-0c4e-43b5-a50e-890f965505ees︠
#As an application, we draw the Farey Tree using this data just to see how it looks
maxlevel=5
show("maxlevel=",maxlevel)
FN=[]
FT=point((0,0))
for i in range(maxlevel):
    FN.append([])
FN.insert(0,[vector((1,0)),vector((1,1))])
for level in range(1,maxlevel+1):
    for i in range(len(FN[level-1])-1):
        (FN[level]).append(FN[level-1][i])
        (FN[level]).append(FN[level-1][i]+FN[level-1][i+1])
    (FN[level]).append(FN[level-1][i+1])
for i in range(maxlevel+1):
    if i<=5:
        show("level=",i,":",FN[i])
def offsprings(point,level):
    i=FN[level+1].index(point)
    return [(FN[level+1][i-1],level+1),(FN[level+1][i+1],level+1)]
FT=point((0,0))
#A point is a vector in the plane
#A pl is a pair of a point and a level in which that point lies.
def drawfareytree(pl):
    """
    Draws the Farey tree in the plane starting at pl;
    pl is pair of a vector in the plane, and the level
    """
    global FT
    p=pl[0];#The point
    l=pl[1];#The level
    #show(p)
    #show("current level=",l,"; maxlevel=",maxlevel)
    if l>=maxlevel:
        #show("level>=maxlevel")
        return
    else:
        #show("se ejecutó esta primero")
        leftchild,rightchild=offsprings(*pl)
        #show("Se ejecutó esta linea")
        FT+= point(myf(*p),color=hue(l/maxlevel),size=.3)
        FT+= point(myf(*leftchild[0]),color=hue((l-1)/(maxlevel-1)),size=.3)+\
            line([myf(*p),myf(*leftchild[0])],color=hue((l-1)/(maxlevel-1)),thickness=.3) #+text(str(leftchild[0]),myf(*leftchild[0]),fontsize=5)
        FT+= point(myf(*rightchild[0]),color=hue((l-1)/(maxlevel-1)),size=.3)+\
            line([myf(*p),myf(*rightchild[0])],color=hue((l-1)/(maxlevel-1)),thickness=.3)#+         text(str(rightchild[0]),myf(*rightchild[0]),fontsize=5)
        drawfareytree(leftchild)
        drawfareytree(rightchild)
︡35daf8ed-d2fe-4e6d-92dc-818236725b0c︡{"html":"<div align='center'>maxlevel= $\\displaystyle 5$</div>"}︡{"html":"<div align='center'>level= $\\displaystyle 0$ : [$\\displaystyle \\left(1,\\,0\\right)$, $\\displaystyle \\left(1,\\,1\\right)$]</div>"}︡{"html":"<div align='center'>level= $\\displaystyle 1$ : [$\\displaystyle \\left(1,\\,0\\right)$, $\\displaystyle \\left(2,\\,1\\right)$, $\\displaystyle \\left(1,\\,1\\right)$]</div>"}︡{"html":"<div align='center'>level= $\\displaystyle 2$ : [$\\displaystyle \\left(1,\\,0\\right)$, $\\displaystyle \\left(3,\\,1\\right)$, $\\displaystyle \\left(2,\\,1\\right)$, $\\displaystyle \\left(3,\\,2\\right)$, $\\displaystyle \\left(1,\\,1\\right)$]</div>"}︡{"html":"<div align='center'>level= $\\displaystyle 3$ : [$\\displaystyle \\left(1,\\,0\\right)$, $\\displaystyle \\left(4,\\,1\\right)$, $\\displaystyle \\left(3,\\,1\\right)$, $\\displaystyle \\left(5,\\,2\\right)$, $\\displaystyle \\left(2,\\,1\\right)$, $\\displaystyle \\left(5,\\,3\\right)$, $\\displaystyle \\left(3,\\,2\\right)$, $\\displaystyle \\left(4,\\,3\\right)$, $\\displaystyle \\left(1,\\,1\\right)$]</div>"}︡{"html":"<div align='center'>level= $\\displaystyle 4$ : [$\\displaystyle \\left(1,\\,0\\right)$, $\\displaystyle \\left(5,\\,1\\right)$, $\\displaystyle \\left(4,\\,1\\right)$, $\\displaystyle \\left(7,\\,2\\right)$, $\\displaystyle \\left(3,\\,1\\right)$, $\\displaystyle \\left(8,\\,3\\right)$, $\\displaystyle \\left(5,\\,2\\right)$, $\\displaystyle \\left(7,\\,3\\right)$, $\\displaystyle \\left(2,\\,1\\right)$, $\\displaystyle \\left(7,\\,4\\right)$, $\\displaystyle \\left(5,\\,3\\right)$, $\\displaystyle \\left(8,\\,5\\right)$, $\\displaystyle \\left(3,\\,2\\right)$, $\\displaystyle \\left(7,\\,5\\right)$, $\\displaystyle \\left(4,\\,3\\right)$, $\\displaystyle \\left(5,\\,4\\right)$, $\\displaystyle \\left(1,\\,1\\right)$]</div>"}︡{"html":"<div align='center'>level= $\\displaystyle 5$ : [$\\displaystyle \\left(1,\\,0\\right)$, $\\displaystyle \\left(6,\\,1\\right)$, $\\displaystyle \\left(5,\\,1\\right)$, $\\displaystyle \\left(9,\\,2\\right)$, $\\displaystyle \\left(4,\\,1\\right)$, $\\displaystyle \\left(11,\\,3\\right)$, $\\displaystyle \\left(7,\\,2\\right)$, $\\displaystyle \\left(10,\\,3\\right)$, $\\displaystyle \\left(3,\\,1\\right)$, $\\displaystyle \\left(11,\\,4\\right)$, $\\displaystyle \\left(8,\\,3\\right)$, $\\displaystyle \\left(13,\\,5\\right)$, $\\displaystyle \\left(5,\\,2\\right)$, $\\displaystyle \\left(12,\\,5\\right)$, $\\displaystyle \\left(7,\\,3\\right)$, $\\displaystyle \\left(9,\\,4\\right)$, $\\displaystyle \\left(2,\\,1\\right)$, $\\displaystyle \\left(9,\\,5\\right)$, $\\displaystyle \\left(7,\\,4\\right)$, $\\displaystyle \\left(12,\\,7\\right)$, $\\displaystyle \\left(5,\\,3\\right)$, $\\displaystyle \\left(13,\\,8\\right)$, $\\displaystyle \\left(8,\\,5\\right)$, $\\displaystyle \\left(11,\\,7\\right)$, $\\displaystyle \\left(3,\\,2\\right)$, $\\displaystyle \\left(10,\\,7\\right)$, $\\displaystyle \\left(7,\\,5\\right)$, $\\displaystyle \\left(11,\\,8\\right)$, $\\displaystyle \\left(4,\\,3\\right)$, $\\displaystyle \\left(9,\\,7\\right)$, $\\displaystyle \\left(5,\\,4\\right)$, $\\displaystyle \\left(6,\\,5\\right)$, $\\displaystyle \\left(1,\\,1\\right)$]</div>"}︡{"done":true}︡
︠75a7dc58-dfa5-43bc-82ff-5dfc11f2e0e2s︠
drawfareytree((vector([2,1]),1))
︡3971e08a-b57f-48ce-a164-79ecc42d829d︡{"done":true}︡
︠a455a1aa-f2d1-4375-96e4-64f32eec9bbas︠
(H+G+FT).show(aspect_ratio=1,figsize=10)
︡6738cc15-5999-456c-9356-ce06ab4db4e7︡{"file":{"filename":"/home/user/.sage/temp/project-0e2295c1-fb40-4d14-a8b4-83cc20956ee4/308/tmp_fP0GBt.svg","show":true,"text":null,"uuid":"da34097d-411b-46a0-8d32-c684267340ba"},"once":false}︡{"done":true}︡
︠5bbc34e4-82c4-4337-8125-6c93ca907b4fs︠
#Next we will try to have the rerpesentation of the continued fraction drawn as in this projective plane:

def square(origin,size, color=hue(0)):
    origin=vector(origin)
    v1,v2,v3,v4=\
        origin,\
        origin+vector([size,0]),\
        origin+vector([size,size]),\
        origin+vector([0,size])
    return line([myf(*v1),myf(*v2),myf(*v3),myf(*v4),myf(*v1)],color=color)
def squares(origin, size, repeats, direction, color=hue(0)):
    """
    origin is the begining of the squares,
    size is the number of squares to draw
    repeats is the numbers of squares to draw
    direction: 0 means towards the right; 1 upwards
    """
    G=Graphics()
    origin=vector(origin)
    if direction==0:
        dv=vector((size,0))
    else:
        dv=vector((0,size))
    for i in range(repeats):
        G+=square(origin+i*dv, size, color=color)
    return G
def MyQd(number):
    """
    This gives the quotients and the divisors in Euclid's Algorithm.
    It is not as efficient as the continued fraction routine,
    but it gives the devisors.
    """
    d0=number.numerator()
    D0=number.denominator()
    d=[d0]
    D=[D0]
    r=[]
    Q=[]
    while D0>0:
        r0=d0%D0
        r.append(r0)
        Q0=int(d0/D0)
        Q.append(Q0)
        d0=D0
        D0=r0
        D.append(D0)
        d.append(d0)
    D.pop()
    return Q,D
show(MyQd(68/157))
︡8028b1dd-92a6-46db-ab9d-cddec39fd93a︡{"html":"<div align='center'>([$\\displaystyle 0$, $\\displaystyle 2$, $\\displaystyle 3$, $\\displaystyle 4$, $\\displaystyle 5$], [$\\displaystyle 157$, $\\displaystyle 68$, $\\displaystyle 21$, $\\displaystyle 5$, $\\displaystyle 1$])</div>"}︡{"done":true}︡
︠ec4c5b00-8aa7-4e5b-833e-0fea080a3b16s︠
def drawcontfrac(number, origin=(1,1),color=hue(0)):
    """
    Draws several rectangles giving a picture of the 
    continuous fraction expantion for number
    Assumes that number<1, and that number is rational.
    A recursive version is possible, but this one is iterative.
    The main idea is that for the fraction 68/157 whose sequence
    of quotients is Q=[0,2,3,4,5], and whose sequence of Divisors
    is D=[157, 68,21,5,1], the rectangle is drawn as follows:
    dv=[vector((1,0)),vector((0,1))]
    O=vector((0,0))
    #The number is 68/157
    G = squares(O,68,2,0)+\
        squares(O+2*68*(dv[0]),21,3,1)+\
        squares(O+2*68*(dv[0])+3*21*(dv[1]),5,4,0)+\
        squares(O+2*68*(dv[0])+3*21*(dv[1])+4*5*(dv[0]),1,5,1)
    G.show(aspect_ratio=1,gridlines=[srange(0,157,10),srange(0,68,10)],figsize=8)
    """
    dv=[vector((1,0)),vector((0,1))]
    Q,D=MyQd(number);#Q is the sequence of Quotients, and D is the sequence of Divisors
    Q.pop(0)
    D.pop(0);#We are assuming that the number is less than one
    G=Graphics()
    O=vector(origin);#A recursive version is also possilbe; but this solution is iterative
    for i in range(len(Q)):
        G+=squares(O,D[i],Q[i],(i%2),color=color)
        O+=D[i]*Q[i]*dv[i%2]
    return G
DC=drawcontfrac(68/157,origin=(1,1))
DC.show(aspect_ratio=1)
︡a4857527-5b55-4446-a8b2-87faad9f1151︡{"file":{"filename":"/home/user/.sage/temp/project-0e2295c1-fb40-4d14-a8b4-83cc20956ee4/308/tmp_Fz1bSa.svg","show":true,"text":null,"uuid":"b6f6faf2-97c2-4c3b-a9b5-accf567c5011"},"once":false}︡{"done":true}︡
︠8de6c214-f17b-4a38-8dd6-c54c1146efb5s︠
SS=squares((2,1),1,5,0)
(H+G+SS).show(aspect_ratio=1)
SS1=square((3,1),1)
(H+G+SS1).show(aspect_ratio=1)
︡461b7312-547d-4b3b-b17c-ba163faaad99︡{"file":{"filename":"/home/user/.sage/temp/project-0e2295c1-fb40-4d14-a8b4-83cc20956ee4/308/tmp_IiJAgn.svg","show":true,"text":null,"uuid":"03e57337-fac8-4c5d-b130-45bd4b9c995b"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-0e2295c1-fb40-4d14-a8b4-83cc20956ee4/308/tmp_szkWgM.svg","show":true,"text":null,"uuid":"ce22f3a8-5e46-4a4c-aa5f-8c5a6f281483"},"once":false}︡{"done":true}︡
︠7d67c381-2b95-4fb2-9e4b-6724ad204339s︠
T=Graphics()
for i in range(1,8):
    for j in range(0,i+1):
        T+=text(str((i,j)),myf(i,j),fontsize=20/i)
show(H+G+FT+T+squares((5,2),1,3,1),aspect_ratio=1,figsize=12)
︡f0286e50-ae82-4fc8-85c7-df709f036c50︡{"file":{"filename":"/home/user/.sage/temp/project-0e2295c1-fb40-4d14-a8b4-83cc20956ee4/308/tmp_PTmAV4.svg","show":true,"text":null,"uuid":"6e2014d7-b90a-47a1-bbce-8b1237f6408c"},"once":false}︡{"done":true}︡
︠0c20e731-9fd7-43b0-b032-f08c6c31dfdfs︠
DC=drawcontfrac(1/2,(2,1))+drawcontfrac(1/3,(3,1))+drawcontfrac(2/5,(5,2))+drawcontfrac(2/7,(7,2))
(H+G+FT+T+DC)
︡890a31ee-ac14-47a2-b6d4-3ccf6ca8b241︡{"file":{"filename":"/home/user/.sage/temp/project-0e2295c1-fb40-4d14-a8b4-83cc20956ee4/308/tmp_S65q5Y.svg","show":true,"text":null,"uuid":"d865484f-6668-4d81-af0a-13beb9c95e02"},"once":false}︡{"done":true}︡
︠e94dbc2a-9f71-4637-aa92-e3ad58872ee8︠









